lparameters tcDir, ;
	tnWidth, ;
	tnHeight
local lcDir, ;
	laFiles[1], ;
	lnFiles, ;
	lcNewDir, ;
	lnWidth, ;
	lnHeight, ;
	lnI, ;
	lcFile, ;
	lcNewFile, ;
	loSrcImage, ;
	loResized

* Ask the user for the folder if one wasn't specified.

if vartype(tcDir) <> 'C' or empty(tcDir) or not directory(tcDir)
	lcDir = getdir('', '', 'Select Folder for Photos', 64)
	if empty(lcDir)
		return
	endif empty(lcDir)
else
	lcDir = tcDir
endif vartype(tcDir) <> 'C' ...
lcDir = addbs(lcDir)

* Get all the pictures in the specified folder.

lnFiles = adir(laFiles, lcDir + '*.*')

* Create a Thumbnails folder to hold the resized images.

lcNewDir = lcDir + 'Thumbnails\'
if not directory(lcNewDir)
	md (lcNewDir)
endif not directory(lcNewDir)

* Use a default image size if one wasn't specified.

if pcount() < 3
	lnWidth  = 256
	lnHeight = 192
else
	lnWidth  = tnWidth
	lnHeight = tnHeight
endif pcount() < 3

* Ensure System is available.

do System.app
with _screen.System.Drawing as xfcDrawing of Source\System.PRG

* Do the conversion.

	for lnI = 1 to lnFiles
		lcFile    = lcDir + laFiles[lnI, 1]
		lcNewFile = lcNewDir + 'image' + padl(lnI, 3, '0') + '.jpg'

* Load the original image.

		loSrcImage = .Bitmap.New(lcFile)

* Get the resized version of the image.

		loResized = .Bitmap.New(loSrcImage, lnWidth, lnHeight)

* Save the resized image as a JPEG.

		loResized.Save(lcNewFile, .Imaging.ImageFormat.JPEG)
	next lnI
endwith 
return












