local loGFX as xfcGraphics of Source\System.Drawing.PRG, ;
	loPen as xfcPen of Source\System.Drawing.PRG

* Ensure GDIPlusX is available.

do System.app
clear
with _screen.System.Drawing as xfcDrawing of Source\System.PRG

* Create a Graphics object. We'll create it by calling FromHWnd and passing it
* the handle (HWnd) to _SCREEN, which means we'll be drawing directly on
* _SCREEN.

	loGfx = .Graphics.FromHWnd(_screen.HWnd)

* Fill an ellipse using a blue brush. System.Drawing.Brushes provides a set of
* brushes with pre-defined colors, such as blue. The other parameters are the X
* and Y location of the upper-left corner of the ellipse and its width and
* height.

	loGfx.FillEllipse(.Brushes.Blue, 30, 30, 400, 200)

* Create a red pen. The New method of System.Drawing.Pen creates a pen using a
* specified color and width. Note that the color is specified as a color
* brush. In this case, we'll use the Red member of System.Drawing.Color.

	loPen = .Pen.New(.Color.Red, 2)

* Here's another way to get the desired color.

*	loColor = .Color.FromRGB(rgb(255, 0, 0))
*	loPen   = .Pen.New(loColor, 2)

* Draw a rectangle using the pen. As with ellipses, the parameters specify the
* X and Y location of the upper-left corner and its width and height.

	loGfx.DrawRectangle(loPen, 20, 20, 420, 220)

* Here's another way to draw, using a RectangleF object instead.

*	loRect = .RectangleF.New(20, 20, 420, 220)
*	loGfx.DrawRectangle(loPen, loRect)
endwith










